/*
 *	GPU Packet related routines
 *	Greeting: k-comm, NOT YAROZE
 */
#include "syscall.h"
#include "gpupkt.h"

void FillRect(RECT *pRect, RGB24 fg)
{
	/* COMMAND 02  RECTANGLE  16dot Eɕ␳Ă܂悤Ŏg܂B */
#if 0
	struct {
		unsigned char r,g,b,code;
		RECT rect;
	} pkt;
	memcpy(&pkt, &fg, 4);
	
	pkt.code = 0x02;	/* Rectangle */
	pkt.rect = *pRect;
#endif
	struct {
		unsigned char r,g,b,code;
		ulong o0, o1, o2, o3;
	} pkt;
	memcpy(&pkt, &fg, 4);
	pkt.code = 0x28;
	pkt.o0 = (pRect->y << 16) | pRect->x;
	pkt.o1 = (pRect->y << 16) | (pRect->x + pRect->w);
	pkt.o2 = ((pRect->y + pRect->h) << 16) | pRect->x;
	pkt.o3 = ((pRect->y + pRect->h) << 16) | (pRect->x + pRect->w);
	
	GPU_cwb((long *)&pkt, sizeof (pkt) / 4);
	return;
}
void ClearScreen(RGB24 rgb)
{
/*	RGB24 rgb = MKRGB24(0,0,0); */
	RECT rect = {
		0,0,
		1023,511
	};

	FillRect(&rect, rgb);
}

void DrawRect(RECT *pRect, RGB24 fg)
{
/*******
	struct {
		unsigned char r,g,b,code;
		RECT rect;
	} pkt;
	
	memcpy(&pkt, &fg, 4);
	pkt.code = 0x60;
	pkt.rect = *pRect;
********/

	struct {
		unsigned char r,g,b,code;
		ulong o0, o1, o2, o3, o4, eop;
	} pkt;

	memcpy(&pkt, &fg, 4);
	pkt.code = 0x4c;
	pkt.o0 = (pRect->y << 16) | pRect->x;
	pkt.o1 = (pRect->y << 16) | (pRect->x + pRect->w -1);
	pkt.o2 = ((pRect->y + pRect->h -1) << 16) | (pRect->x + pRect->w -1);
	pkt.o3 = ((pRect->y + pRect->h -1) << 16) | pRect->x;
	pkt.o4 = pkt.o0;
	pkt.eop = 0x55555555;
	
	GPU_cwb((long *)&pkt, sizeof (pkt) / 4);
	return;
}

void CopyImage(RECT *pSrc, short destX, short destY)
{
	struct {
		unsigned char r,g,b,code;
		short srcX, srcY;
		short destX, destY;
		short w, h;
	} pkt;

	*(ulong *)&pkt = 0;
	pkt.code = 0x80;
	pkt.srcX = pSrc->x;
	pkt.srcY = pSrc->y;
	pkt.w = pSrc->w;
	pkt.h = pSrc->h;
	pkt.destX = destX;
	pkt.destY = destY;

	GPU_cwb((long *)&pkt, sizeof (pkt) / 4);
	return;
}

void DrawLine(RECT *pRect, RGB24 c1, RGB24 c2)
{
	struct {
		RGB24 c1;
		short x1,y1;
		RGB24 c2;
		short x2,y2;
	} pkt;

	pkt.c1 = c1;	
	pkt.c1 |= 0x50 << 24;
	pkt.c2 = c2;	
	pkt.x1 = pRect->x;
	pkt.y1 = pRect->y;
	pkt.x2 = pRect->x + pRect->w - 1;
	pkt.y2 = pRect->y + pRect->h - 1;

	GPU_cwb((long *)&pkt, sizeof (pkt) / 4);
	return;
}


