 #include "mytypes.h"
#include "syscall.h"
#include "par3com.h"

static void InitAll(void);
int par3restore(unsigned long addr);

uchar PadBuf[9];

#define TIMEOUTVAL	0x7fff
#define RUN_STATUS	'H'

int main(int argc, char **argv)
{
	int n;
	volatile uchar *recv = (uchar *)0x1f060000;
	volatile uchar *button = (uchar *)0x1f060018;
	uchar c;
	int end;
	RECT rect = { 0, 120, 320, 120 };
/**	int runningStatuses[3] = { 1,2,RUN_STATUS}; **/
/**	int run = 2; **/
/**	char waiting[] = "xx Waiting..."; **/
	const char version[] = "P\x03\x31\040Action Replay ReflashTool Ver0.2";
									/*   12345678901234567890123456789012 */
	int i;
	int len;
	int y;
	int oldCommand;
	
	InitAll();
	GPU_sync();
	CD_Control(7);	/* STANDBY */
	
	ShowTitle();	/* x */
	*(uchar *)0x1f060008 = 0; /* LPT |[gNA */

	sendGPU(0x03000001, true);					/* ʕ\ OFF */
	ClearScreen(MKRGB24(0,0,0));
	GPU_sync();
	sendGPU(0x03000000, true);	/* ʕ\ */

	y = 28;
	/*        123456789012345678901234567890123 */
	FontPuts("Action Replay ReflashTool Ver0.20",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
		MKSHORT_YX(y, (320 - 8 * 33) >> 1)
		);
	y += 16;
	/*        12345678901234567890123456789012 */
	FontPuts("Programmed by Hanimar.",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
		MKSHORT_YX(y, (320 - 8 * 22) >> 1)
		);
	y += 24;
	if (isSst28xF040() != 0x04bf) {
	/*            123456789 123456789 123456789 123456789  */
		FontPuts("Couldn't detect EEPROM,SST 28xF040.\r\n"
		         "Probably program can't flash ROM...\r\n",
			MKRGB15(0xff, 0xff, 0x00), MKRGB15(0,0,0),
			MKSHORT_YX(y, 20)
			);
	}

START:
/***
	waiting[0] = '0' + ((runningStatuses[run] >> 4) & 0x0f);
	waiting[1] = '0' + (runningStatuses[run] & 0x0f);
***/

	/*        12345678901234567890123456789 */
	FontPuts("Waiting for PC...",
		MKRGB15(0x00, 0x80, 0x00), MKRGB15(0,0,0),
		MKSHORT_YX(120, (320 - 8 * 17) >> 1)
		);
	GPU_sync();
	bogoVSyncWait2(PadBuf, 1);

	do {
		while ((*recv & 0x10) == 0) {
/*****
			if (*button & 1) {
				while (*button & 1);
				if (++ run > 2) run = 0;
				goto START;
			}
*****/
		}
		c = *recv;
		c &= 0x0f;
	} while (c != 3);
	
	n = Par3exchangeNybble(0, TIMEOUTVAL);
	if (n < 0) goto START;
	if (n != 3) goto START;

	FillRect(&rect, MKRGB24(0, 0, 0));
	GPU_sync();
	FontPuts("Talking...",
		MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
		MKSHORT_YX(120, (320 - 8 * 10) >> 1)
		);
	GPU_sync();
	end = 0;
	
	oldCommand = -1;
	while (!end) {
		if (1 & *button) break;
		n = Par3GetCommand(TIMEOUTVAL);
		if (n < 0) continue;

		switch (n) {
		case 1:		/* Send RAM to PC */
			if (n != oldCommand) {
				FontPuts("Sending.....",
					MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
					MKSHORT_YX(120, (320 - 8 * 12) >> 1)
					);
				GPU_sync();
			}
			PAR3CMD_RAM2PC();
			break;
		case 2: 	/* Recv RAM from PC */
			if (n != oldCommand) {
				FontPuts("Receiving...",
					MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
					MKSHORT_YX(120, (320 - 8 * 12) >> 1)
					);
				GPU_sync();
			}
			PAR3CMD_PC2RAM();
			break;
		case 0x65:	/* Returns status */
			end = 1;
/**			Par3exchangeByte(runningStatuses[run], TIMEOUTVAL); **/
			Par3exchangeByte(RUN_STATUS, TIMEOUTVAL);
			break;
		case 0x66: /* Returns version */
			len = version[3] + 4;
			for (i = 0 ; i < len ; i ++)
				Par3exchangeByte(version[i], TIMEOUTVAL);
			
			break;
#if 0
		case 0x67: /* Upgrade */
			for (;;) {
				n = Par3exchangeByte(???, 512);
				if (*button & 1) break;
			}
			end = 1;
			break;
#endif


		/* Original commands, after this */

		case 'B':	/* Backup PAR3 image to 80040000 */
			par3backup(0x80040000);
			Par3exchangeByte(0, TIMEOUTVAL);
			break;
		case 'U':	/* Restore PAR3 image from 80040000 */
			if (n != oldCommand) {
				FontPuts("Flashing....",
					MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
					MKSHORT_YX(120, (320 - 8 * 12) >> 1)
					);
				GPU_sync();
			}
			
			if (par3restore(0x80040000) != 0) {
				Par3exchangeByte(0xff, TIMEOUTVAL);
				
			} else Par3exchangeByte(0, TIMEOUTVAL);
			break;
		case 'X':	/* jalr */
			FlushCache();
			PAR3CMD_EXEC();
			break;
		default:
			end = 1;
			break;
		}
		oldCommand = n;
		/********
		FontPuts("C R A S H ? ",
			MKRGB15(0xff, 0xff, 0xff), MKRGB15(0,0,0),
			MKSHORT_YX(120, (320 - 8 * 12) >> 1)
			);
		*********/
	}
	
	goto START;

	return 0;
}


static void InitAll(void)
{
	int pal;
	
	ExitCriticalSection();

	ResetEntryInt();
	
	bzero(PadBuf, sizeof (PadBuf));	/* pbḧ揉 */
	InitPAD(PadBuf, sizeof (PadBuf), NULL, 0);
	
	/* GPU */
	sendGPU(0, true);							/* Zbg */
	sendGPU(0x03000001, true);					/* ʕ\ OFF */

	pal = IS_SCEE();
	sendGPU(0x05000000 | 0 | ((pal ? 0:8) << 10), true); 	/* \̈n_ 0,0 */

	sendGPU(0x06c60260, true);					/* \͈ */
	sendGPU(pal ? 0x07048030 : 0x07040010, true);	/* \͈ */
	/* 320x240 NTSC/PAL 16bit non interlace */
	sendGPU(0x08000000 | 1 | ( pal ? 8 : 0 ), true);

	GPU_cw(0xe1000400);	/* `惂[hi\̈ɕ` fBUȂ tpage0j*/
	GPU_cw(0xe3000000);	/* `̈n_ (0,0) */
	GPU_cw(0xe407ffff);	/* `̈I_ (1023,511) */
	GPU_cw(0xe5000000);	/* `ItZbg (0,0) */
	
	ClearScreen(MKRGB24(0,0,0));

	StartPAD();

	return;
}

/*
 *	LPI DANGER DANGER... DANGER DANGER...
 *	ROM ɏ݂܂B
 */
int par3restore(unsigned long addr)
{
	uchar *bank = (uchar *)0x1f060030;
	ulong dest, end;
	int i;
	int retry;
	int rc = 0;
	
	/*
	 * SWAP THE BANK TO ROM0.
	 *	ROM N̂̂ɂ܂B
	 */
	*bank = 3;
	for (i = 0x200000 ; i ; i --);	/* KI I'm not sure if this is the best way... */
	
	/* ݋ */
	Sst28xF040_Unprotect();

	end = 0x1f040000;
	for (dest = 0x1f000000 ; dest < end ; dest += 0x100, addr += 0x100) {
		for (retry = 3 ; retry ; retry --) {
			if (Sst28xF040_WriteSector(dest, addr) == 0) break;
		}
		if (retry == 0) { rc = -1; break; }
	}
	/* ݋֎~ */
	Sst28xF040_Protect();
	
	if (rc != 0) return rc;
	

	/*
	 * SWAP THE BANK TO ROM1.
	 *	ROM N̂̂ɂ܂B
	 */
	*bank = 1;
	for (i = 0x200000 ; i ; i --);	/* KI I'm not sure if this is the best way... */
	
	/* ݋ */
	Sst28xF040_Unprotect();

	end = 0x1f040000;
	for (dest = 0x1f000000 ; dest < end ; dest += 0x100, addr += 0x100) {
		for (retry = 3 ; retry ; retry --) {
			if (Sst28xF040_WriteSector(dest, addr) == 0) break;
		}
		if (retry == 0) { rc = -1; break; }
	}
	/* ݋֎~ */
	Sst28xF040_Protect();

	return rc;
}

