##
##	SST 28xF040 related routines.
##


.set noreorder

##
##	Returns: $04bf -> SST 28xF040
##
.globl isSst28xF040
.ent isSst28xF040
isSst28xF040:
	lui	t0, $1f00
	li	t1, $0090	## Read ID
	sb	t1, (t0)
	nop
	lbu	v0, (t0)
	lbu	v1, 1(t0)
	li	t1, $00ff
	sb	t1, (t0)
	sll	v1, v1, 8
	jr	ra
	or	v0, v0, v1
.end isSst28xF040

.globl Sst28xF040_Unprotect
.ent Sst28xF040_Unprotect
Sst28xF040_Unprotect:
	lui	v1, $1f00
	lbu	v0, $1823(v1)
	lbu	v0, $1820(v1)
	lbu	v0, $1822(v1)
	lbu	v0, $0418(v1)
	lbu	v0, $041b(v1)
	lbu	v0, $0419(v1)
	lbu	v0, $041a(v1)
	jr	ra
	nop
.end Sst28xF040_Unprotect

.globl Sst28xF040_Protect
.ent Sst28xF040_Protect
Sst28xF040_Protect:
	lui	v1, $1f00
	lbu	v0, $1823(v1)
	lbu	v0, $1820(v1)
	lbu	v0, $1822(v1)
	lbu	v0, $0418(v1)
	lbu	v0, $041b(v1)
	lbu	v0, $0419(v1)
	lbu	v0, $040a(v1)
	jr	ra
	nop
.end Sst28xF040_Protect

##
##	Sst28xF040_ToggleBit(addr);
##
.ent Sst28xF040_ToggleBit
Sst28xF040_ToggleBit:
	lbu	v0, (a0)
	nop
	lbu	v1, (a0)
	andi	v0, v0, $0040
	andi	v1, v1, $0040
	bne	v0, v1, Sst28xF040_ToggleBit
	nop
	jr	ra
	nop
.end Sst28xF040_ToggleBit

##
##	int Sst28xF040_WriteSector(ulong addr, const char *data);
##
.globl Sst28xF040_WriteSector
.ent Sst28xF040_WriteSector
Sst28xF040_WriteSector:
	addiu	sp, sp, -8
	sw	ra, (sp)
	sw	s0, 4(sp)

	jal	Sst28xF040_ToggleBit

	## SECTOR ERASE
	li	t0, $0020	## sector erase #1
	sb	t0, (a0)
	li	t1, $00d0	## sector erase #2
	sb	t1, (a0)
	jal	Sst28xF040_ToggleBit
	or	t0, zero, a0
	## VERIFY SECTOR ERASE
Sst28xF040_WS0:
	lbu	v0, (t0)
	li	v1, $00ff
	bne	v0, v1, Sst28xF040_WSEND
	addiu	v0, zero, -1
	addiu	t0, t0, 1
	andi	v0, t0, $00ff
	bne	v0, zero, Sst28xF040_WS0
	nop

	## BYTE PROGRAM
	or	t0, zero, a0
	li	t1, $0010	## byte program
Sst28xF040_WS1:
	lbu	s0, (a1)	# s0=*data;
	sb	t1, (t0)	# >> $10
	addiu	a1, a1, 1	# data ++;
	sb	s0, (t0)	# >> s0
	nop
	jal	Sst28xF040_ToggleBit
	nop
	## VERIFY
	lbu	v0, (t0)
	nop
	bne	v0, s0, Sst28xF040_WSEND
	addiu	v0, zero, -1
	
	addiu	t0, t0, 1	# addr ++;
	andi	s0, t0, $00ff	# s0=t0&0xff;
	bne	s0, zero, Sst28xF040_WS1
	or	v0, zero, zero

Sst28xF040_WSEND:
	lw	ra, (sp)
	lw	s0, 4(sp)
	jr	ra
	addiu	sp, sp, 8
.end Sst28xF040_WriteSector

